Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# Q3WidgetStack Class Reference

The Q3WidgetStack class provides a stack of widgets of which only the top widget is user-visible. More...

    #include <Q3WidgetStack>

This class is part of the Qt 3 compatibility library. It is provided to keep old source code working. We strongly advise against using it in new code. See the Porting Guide for more information.

Inherits Q3Frame.

- List of all members, including inherited members

### Writable Properties

- 1 writable property inherited from Q3Frame
- 5 writable properties inherited from QFrame
- 33 writable properties inherited from QWidget
- 1 writable property inherited from QObject

### Read-Only Properties

- 1 read-only property inherited from Q3Frame
- 1 read-only property inherited from QFrame
- 20 read-only properties inherited from QWidget

### Public Functions

- Q3WidgetStack ( QWidget * parent, const char * name = 0, Qt::WFlags f = 0 )
- ~Q3WidgetStack ()
- int addWidget ( QWidget * w, int id = -1 )
- int id ( QWidget * widget ) const
- void removeWidget ( QWidget * w )
- QWidget * visibleWidget () const
- QWidget * widget ( int id ) const

- 1 public function inherited from Q3Frame
- 2 public functions inherited from QFrame
- 92 public functions inherited from QWidget
- 26 public functions inherited from QObject
- 10 public functions inherited from QPaintDevice

### Public Slots

- void raiseWidget ( int id )
- void raiseWidget ( QWidget * w )

- 16 public slots inherited from QWidget
- 1 public slot inherited from QObject

### Signals

- void aboutToShow ( int )
- void aboutToShow ( QWidget * )

- 1 signal inherited from QObject

### Static Public Members

- 4 static public members inherited from QWidget
- 4 static public members inherited from QObject

### Protected Functions

- virtual void setChildGeometries ()

- 5 protected functions inherited from Q3Frame
- 42 protected functions inherited from QWidget
- 7 protected functions inherited from QObject

## Detailed Description

The Q3WidgetStack class provides a stack of widgets of which only the top widget is user-visible.

The application programmer can move any widget to the top of the stack at any time using raiseWidget(), and add or remove widgets using addWidget() and removeWidget(). It is not sufficient to pass the widget stack as parent to a widget which should be inserted into the widgetstack.

visibleWidget() is the get equivalent of raiseWidget(); it returns a pointer to the widget that is currently at the top of the stack.

Q3WidgetStack also provides the ability to manipulate widgets through application-specified integer IDs. You can also translate from widget pointers to IDs using id() and from IDs to widget pointers using widget(). These numeric IDs are unique (per Q3WidgetStack, not globally), but Q3WidgetStack does not attach any additional meaning to them.

The default widget stack is frameless, but you can use the usual Q3Frame functions (such as setFrameStyle()) to add a frame.

Q3WidgetStack provides a signal, aboutToShow(), which is emitted just before a managed widget is shown.

See also QTabDialog, QTabBar, and Q3Frame.

## Member Function Documentation

### Q3WidgetStack::Q3WidgetStack ( QWidget * parent, const char * name = 0, Qt::WFlags f = 0 )

Constructs an empty widget stack.

The parent, name and f arguments are passed to the Q3Frame constructor.

### Q3WidgetStack::~Q3WidgetStack ()

Destroys the object and frees any allocated resources.

### void Q3WidgetStack::aboutToShow ( int ) `[signal]`

This signal is emitted just before a managed widget is shown if that managed widget has an ID != -1. The argument is the numeric ID of the widget.

If you call visibleWidget() in a slot connected to aboutToShow(), the widget it returns is the one that is currently visible, not the one that is about to be shown.

### void Q3WidgetStack::aboutToShow ( QWidget * ) `[signal]`

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

This signal is emitted just before a managed widget is shown. The argument is a pointer to the widget.

If you call visibleWidget() in a slot connected to aboutToShow(), the widget returned is the one that is currently visible, not the one that is about to be shown.

### int Q3WidgetStack::addWidget ( QWidget * w, int id = -1 )

Adds widget w to this stack of widgets, with ID id.

If you pass an id >= 0 this ID is used. If you pass an id of -1 (the default), the widgets will be numbered automatically. If you pass -2 a unique negative integer will be generated. No widget has an ID of -1. Returns the ID or -1 on failure (e.g. w is 0).

If you pass an id that is already used, then a unique negative integer will be generated to prevent two widgets having the same id.

If w is not a child of this Q3WidgetStack moves it using reparent().

### int Q3WidgetStack::id ( QWidget * widget ) const

Returns the ID of the widget. Returns -1 if widget is 0 or is not being managed by this widget stack.

See also widget() and addWidget().

### void Q3WidgetStack::raiseWidget ( int id ) `[slot]`

Raises the widget with ID id to the top of the widget stack.

See also visibleWidget().

### void Q3WidgetStack::raiseWidget ( QWidget * w ) `[slot]`

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

Raises widget w to the top of the widget stack.

### void Q3WidgetStack::removeWidget ( QWidget * w )

Removes widget w from this stack of widgets. Does not delete w. If w is the currently visible widget, no other widget is substituted.

See also visibleWidget() and raiseWidget().

### void Q3WidgetStack::setChildGeometries () `[virtual protected]`

Fixes up the children's geometries.

### QWidget * Q3WidgetStack::visibleWidget () const

Returns the currently visible widget (the one at the top of the stack), or 0 if nothing is currently being shown.

See also aboutToShow(), id(), and raiseWidget().

### QWidget * Q3WidgetStack::widget ( int id ) const

Returns the widget with ID id. Returns 0 if this widget stack does not manage a widget with ID id.

See also id() and addWidget().